=== debian/changelog ===
supercollider (1:3.10.0.1+rb2-1+eagle) unstable; urgency=medium

  * update

 -- Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>  Wed, 27 Jan 2021 09:39:41 +0800
